/* Generated by wayland-scanner 1.20.0 */

#ifndef AGL_SHELL_CLIENT_PROTOCOL_H
#define AGL_SHELL_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_agl_shell The agl_shell protocol
 * @section page_ifaces_agl_shell Interfaces
 * - @subpage page_iface_agl_shell - user interface for Automotive Grade Linux platform
 * - @subpage page_iface_agl_shell_ext - extended user interface for Automotive Grade Linux platform
 * @section page_copyright_agl_shell Copyright
 * <pre>
 *
 * Copyright © 2019, 2022 Collabora, Ltd.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct agl_shell;
struct agl_shell_ext;
struct wl_output;
struct wl_surface;

#ifndef AGL_SHELL_INTERFACE
#define AGL_SHELL_INTERFACE
/**
 * @page page_iface_agl_shell agl_shell
 * @section page_iface_agl_shell_desc Description
 *
 * Starting with version 2 of the protocol, the client is required to wait
 * for the 'bound_ok' or 'bound_fail' events in order to proceed further.
 *
 * In case the client gets a 'bound_fail' event then it should consider that
 * there's another client already bound to the agl_shell protocol.
 * A client that receives a 'bound_ok' event should consider that there's
 * no other client already bound to the interface and can proceed further.
 *
 * If the client uses an older version of the protocol it will receive
 * automatically an error and the compositor will terminate the connection,
 * if there's another client already bound the interface.
 *
 * If the client receives the 'bound_fail' event and attempts to use the
 * interface further it will receive an error and the compositor will
 * terminate the connection. After the 'bound_fail' event was received the
 * client should call the destructor, which has been added with version 2
 * of the protocol. The client is free to try at a later point in time to
 * see if it will receive the 'bound_ok' event, but there's no explicit way
 * of finding out when that event will be delivered.
 * It is assumed that it can infer that information through other
 * means/other channels.
 * @section page_iface_agl_shell_api API
 * See @ref iface_agl_shell.
 */
/**
 * @defgroup iface_agl_shell The agl_shell interface
 *
 * Starting with version 2 of the protocol, the client is required to wait
 * for the 'bound_ok' or 'bound_fail' events in order to proceed further.
 *
 * In case the client gets a 'bound_fail' event then it should consider that
 * there's another client already bound to the agl_shell protocol.
 * A client that receives a 'bound_ok' event should consider that there's
 * no other client already bound to the interface and can proceed further.
 *
 * If the client uses an older version of the protocol it will receive
 * automatically an error and the compositor will terminate the connection,
 * if there's another client already bound the interface.
 *
 * If the client receives the 'bound_fail' event and attempts to use the
 * interface further it will receive an error and the compositor will
 * terminate the connection. After the 'bound_fail' event was received the
 * client should call the destructor, which has been added with version 2
 * of the protocol. The client is free to try at a later point in time to
 * see if it will receive the 'bound_ok' event, but there's no explicit way
 * of finding out when that event will be delivered.
 * It is assumed that it can infer that information through other
 * means/other channels.
 */
extern const struct wl_interface agl_shell_interface;
#endif
#ifndef AGL_SHELL_EXT_INTERFACE
#define AGL_SHELL_EXT_INTERFACE
/**
 * @page page_iface_agl_shell_ext agl_shell_ext
 * @section page_iface_agl_shell_ext_desc Description
 *
 * This interface allows another client bind to the agl_shell interface,
 * while there's another shell client already present.
 *
 * The client should first bind to this interface and then inform the
 * compositor with the 'doas_shell_client' request and it wants to bind to
 * the agl_shell interface. The client is still expected, if using a new
 * version of the agl_shell interface, to wait for the 'bound_ok' and
 * 'bound_fail' events before issueing any other requests/events.
 *
 * Note that this interface has its limitations, and the compositor would
 * still refuse the act for 'set_panel' or 'set_background' requests
 * of the agl_shell interface if there's already a client that used them.
 *
 * Any other requests or events should be delievered and handled as it would
 * a client bound to the agl_shell interface.
 * @section page_iface_agl_shell_ext_api API
 * See @ref iface_agl_shell_ext.
 */
/**
 * @defgroup iface_agl_shell_ext The agl_shell_ext interface
 *
 * This interface allows another client bind to the agl_shell interface,
 * while there's another shell client already present.
 *
 * The client should first bind to this interface and then inform the
 * compositor with the 'doas_shell_client' request and it wants to bind to
 * the agl_shell interface. The client is still expected, if using a new
 * version of the agl_shell interface, to wait for the 'bound_ok' and
 * 'bound_fail' events before issueing any other requests/events.
 *
 * Note that this interface has its limitations, and the compositor would
 * still refuse the act for 'set_panel' or 'set_background' requests
 * of the agl_shell interface if there's already a client that used them.
 *
 * Any other requests or events should be delievered and handled as it would
 * a client bound to the agl_shell interface.
 */
extern const struct wl_interface agl_shell_ext_interface;
#endif

#ifndef AGL_SHELL_ERROR_ENUM
#define AGL_SHELL_ERROR_ENUM
enum agl_shell_error {
	AGL_SHELL_ERROR_INVALID_ARGUMENT = 0,
	AGL_SHELL_ERROR_BACKGROUND_EXISTS = 1,
	AGL_SHELL_ERROR_PANEL_EXISTS = 2,
};
#endif /* AGL_SHELL_ERROR_ENUM */

#ifndef AGL_SHELL_EDGE_ENUM
#define AGL_SHELL_EDGE_ENUM
enum agl_shell_edge {
	AGL_SHELL_EDGE_TOP = 0,
	AGL_SHELL_EDGE_BOTTOM = 1,
	AGL_SHELL_EDGE_LEFT = 2,
	AGL_SHELL_EDGE_RIGHT = 3,
};
#endif /* AGL_SHELL_EDGE_ENUM */

#ifndef AGL_SHELL_APP_STATE_ENUM
#define AGL_SHELL_APP_STATE_ENUM
enum agl_shell_app_state {
	AGL_SHELL_APP_STATE_STARTED = 0,
	AGL_SHELL_APP_STATE_TERMINATED = 1,
	AGL_SHELL_APP_STATE_ACTIVATED = 2,
	AGL_SHELL_APP_STATE_DEACTIVATED = 3,
};
#endif /* AGL_SHELL_APP_STATE_ENUM */

/**
 * @ingroup iface_agl_shell
 * @struct agl_shell_listener
 */
struct agl_shell_listener {
	/**
	 * event sent if binding was ok
	 *
	 * Informs the client that it was able to bind the agl_shell
	 * interface succesfully. Clients are required to wait for this
	 * event before continuing further.
	 * @since 2
	 */
	void (*bound_ok)(void *data,
			 struct agl_shell *agl_shell);
	/**
	 * event sent if binding was nok
	 *
	 * Informs the client that binding to the agl_shell interface was
	 * unsuccesfull. Clients are required to wait for this event for
	 * continuing further.
	 * @since 2
	 */
	void (*bound_fail)(void *data,
			   struct agl_shell *agl_shell);
	/**
	 * event sent when an application suffered state modification
	 *
	 * Informs the client that an application has changed its state
	 * to another, specified by the app_state enum. Client can use this
	 * event to track current application state. For instance to know
	 * when the application has started, or when terminated/stopped.
	 * @since 3
	 */
	void (*app_state)(void *data,
			  struct agl_shell *agl_shell,
			  const char *app_id,
			  uint32_t state);
};

/**
 * @ingroup iface_agl_shell
 */
static inline int
agl_shell_add_listener(struct agl_shell *agl_shell,
		       const struct agl_shell_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) agl_shell,
				     (void (**)(void)) listener, data);
}

#define AGL_SHELL_READY 0
#define AGL_SHELL_SET_BACKGROUND 1
#define AGL_SHELL_SET_PANEL 2
#define AGL_SHELL_ACTIVATE_APP 3
#define AGL_SHELL_DESTROY 4
#define AGL_SHELL_SET_ACTIVATE_REGION 5

/**
 * @ingroup iface_agl_shell
 */
#define AGL_SHELL_BOUND_OK_SINCE_VERSION 2
/**
 * @ingroup iface_agl_shell
 */
#define AGL_SHELL_BOUND_FAIL_SINCE_VERSION 2
/**
 * @ingroup iface_agl_shell
 */
#define AGL_SHELL_APP_STATE_SINCE_VERSION 3

/**
 * @ingroup iface_agl_shell
 */
#define AGL_SHELL_READY_SINCE_VERSION 1
/**
 * @ingroup iface_agl_shell
 */
#define AGL_SHELL_SET_BACKGROUND_SINCE_VERSION 1
/**
 * @ingroup iface_agl_shell
 */
#define AGL_SHELL_SET_PANEL_SINCE_VERSION 1
/**
 * @ingroup iface_agl_shell
 */
#define AGL_SHELL_ACTIVATE_APP_SINCE_VERSION 1
/**
 * @ingroup iface_agl_shell
 */
#define AGL_SHELL_DESTROY_SINCE_VERSION 2
/**
 * @ingroup iface_agl_shell
 */
#define AGL_SHELL_SET_ACTIVATE_REGION_SINCE_VERSION 4

/** @ingroup iface_agl_shell */
static inline void
agl_shell_set_user_data(struct agl_shell *agl_shell, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) agl_shell, user_data);
}

/** @ingroup iface_agl_shell */
static inline void *
agl_shell_get_user_data(struct agl_shell *agl_shell)
{
	return wl_proxy_get_user_data((struct wl_proxy *) agl_shell);
}

static inline uint32_t
agl_shell_get_version(struct agl_shell *agl_shell)
{
	return wl_proxy_get_version((struct wl_proxy *) agl_shell);
}

/**
 * @ingroup iface_agl_shell
 *
 * Tell the server that this client is ready to be shown. The server
 * will delay presentation during start-up until all shell clients are
 * ready to be shown, and will display a black screen instead.
 * This gives the client an opportunity to set up and configure several
 * surfaces into a coherent interface.
 *
 * The client that binds to this interface must send this request, otherwise
 * they may stall the compositor unnecessarily.
 *
 * If this request is called after the compositor has already finished
 * start-up, no operation is performed.
 */
static inline void
agl_shell_ready(struct agl_shell *agl_shell)
{
	wl_proxy_marshal_flags((struct wl_proxy *) agl_shell,
			 AGL_SHELL_READY, NULL, wl_proxy_get_version((struct wl_proxy *) agl_shell), 0);
}

/**
 * @ingroup iface_agl_shell
 *
 * Set the surface to act as the background of an output. After this
 * request, the server will immediately send a configure event with
 * the dimensions the client should use to cover the entire output.
 *
 * The surface must have a "desktop" surface role, as supported by
 * libweston-desktop.
 *
 * Only a single surface may be the background for any output. If a
 * background surface already exists, a protocol error is raised.
 */
static inline void
agl_shell_set_background(struct agl_shell *agl_shell, struct wl_surface *surface, struct wl_output *output)
{
	wl_proxy_marshal_flags((struct wl_proxy *) agl_shell,
			 AGL_SHELL_SET_BACKGROUND, NULL, wl_proxy_get_version((struct wl_proxy *) agl_shell), 0, surface, output);
}

/**
 * @ingroup iface_agl_shell
 *
 * Set the surface to act as a panel of an output. The 'edge' argument
 * says what edge of the output the surface will be anchored to.
 * After this request, the server will send a configure event with the
 * corresponding width/height that the client should use, and 0 for the
 * other dimension. E.g. if the edge is 'top', the width will be the
 * output's width, and the height will be 0.
 *
 * The surface must have a "desktop" surface role, as supported by
 * libweston-desktop.
 *
 * The compositor will take the panel's window geometry into account when
 * positioning other windows, so the panels are not covered.
 *
 * XXX: What happens if e.g. both top and left are used at the same time?
 * Who gets to have the corner?
 *
 * Only a single surface may be the panel for an output's edge. If a
 * surface already exists on an edge, a protocol error is raised.
 */
static inline void
agl_shell_set_panel(struct agl_shell *agl_shell, struct wl_surface *surface, struct wl_output *output, uint32_t edge)
{
	wl_proxy_marshal_flags((struct wl_proxy *) agl_shell,
			 AGL_SHELL_SET_PANEL, NULL, wl_proxy_get_version((struct wl_proxy *) agl_shell), 0, surface, output, edge);
}

/**
 * @ingroup iface_agl_shell
 *
 * Ask the compositor to make a toplevel to become the current/focused
 * window for window management purposes.
 *
 * See xdg_toplevel.set_app_id from the xdg-shell protocol for a
 * description of app_id.
 *
 * If multiple toplevels have the same app_id, the result is unspecified.
 *
 * XXX: Do we need feedback to say it didn't work? (e.g. client does
 * not exist)
 */
static inline void
agl_shell_activate_app(struct agl_shell *agl_shell, const char *app_id, struct wl_output *output)
{
	wl_proxy_marshal_flags((struct wl_proxy *) agl_shell,
			 AGL_SHELL_ACTIVATE_APP, NULL, wl_proxy_get_version((struct wl_proxy *) agl_shell), 0, app_id, output);
}

/**
 * @ingroup iface_agl_shell
 *
 */
static inline void
agl_shell_destroy(struct agl_shell *agl_shell)
{
	wl_proxy_marshal_flags((struct wl_proxy *) agl_shell,
			 AGL_SHELL_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) agl_shell), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_agl_shell
 *
 * A hint for the compositor to use a custom area, rather than
 * inferring the activation area. If any panels are used
 * the compositor computes the activation area by subtracting the
 * panels geometry area. If no panels are used then the entire output
 * is being used. This request changes that as to hint the compositor
 * to use the supplied rectangle and ignore any potential panels
 * that might been set-up previously.
 *
 * In order for this request to take effect it will need to happen
 * before the 'ready' request in order for the compositor to make use of it.
 * Note that any 'set_panel' request be will not be honored, if this request
 * has been called.
 *
 * The x and y coordinates use the top-left corner as the origin. The
 * rectangle area shouldn't exceed the output area, while an area smaller
 * than the output, would basically result in showing up the background
 * surface.
 */
static inline void
agl_shell_set_activate_region(struct agl_shell *agl_shell, struct wl_output *output, int32_t x, int32_t y, int32_t width, int32_t height)
{
	wl_proxy_marshal_flags((struct wl_proxy *) agl_shell,
			 AGL_SHELL_SET_ACTIVATE_REGION, NULL, wl_proxy_get_version((struct wl_proxy *) agl_shell), 0, output, x, y, width, height);
}

#ifndef AGL_SHELL_EXT_DOAS_SHELL_CLIENT_STATUS_ENUM
#define AGL_SHELL_EXT_DOAS_SHELL_CLIENT_STATUS_ENUM
enum agl_shell_ext_doas_shell_client_status {
	AGL_SHELL_EXT_DOAS_SHELL_CLIENT_STATUS_SUCCESS = 0,
	AGL_SHELL_EXT_DOAS_SHELL_CLIENT_STATUS_FAILED = 1,
};
#endif /* AGL_SHELL_EXT_DOAS_SHELL_CLIENT_STATUS_ENUM */

/**
 * @ingroup iface_agl_shell_ext
 * @struct agl_shell_ext_listener
 */
struct agl_shell_ext_listener {
	/**
	 * event sent as a reply to doas_shell_client
	 *
	 * The client should check the status event to verify that the
	 * compositor was able to handle the request.
	 */
	void (*doas_done)(void *data,
			  struct agl_shell_ext *agl_shell_ext,
			  uint32_t status);
};

/**
 * @ingroup iface_agl_shell_ext
 */
static inline int
agl_shell_ext_add_listener(struct agl_shell_ext *agl_shell_ext,
			   const struct agl_shell_ext_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) agl_shell_ext,
				     (void (**)(void)) listener, data);
}

#define AGL_SHELL_EXT_DESTROY 0
#define AGL_SHELL_EXT_DOAS_SHELL_CLIENT 1

/**
 * @ingroup iface_agl_shell_ext
 */
#define AGL_SHELL_EXT_DOAS_DONE_SINCE_VERSION 1

/**
 * @ingroup iface_agl_shell_ext
 */
#define AGL_SHELL_EXT_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_agl_shell_ext
 */
#define AGL_SHELL_EXT_DOAS_SHELL_CLIENT_SINCE_VERSION 1

/** @ingroup iface_agl_shell_ext */
static inline void
agl_shell_ext_set_user_data(struct agl_shell_ext *agl_shell_ext, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) agl_shell_ext, user_data);
}

/** @ingroup iface_agl_shell_ext */
static inline void *
agl_shell_ext_get_user_data(struct agl_shell_ext *agl_shell_ext)
{
	return wl_proxy_get_user_data((struct wl_proxy *) agl_shell_ext);
}

static inline uint32_t
agl_shell_ext_get_version(struct agl_shell_ext *agl_shell_ext)
{
	return wl_proxy_get_version((struct wl_proxy *) agl_shell_ext);
}

/**
 * @ingroup iface_agl_shell_ext
 *
 * Call the destructor once you're ready with agl_shell_ext interface.
 * This would reset the state and would make any requests made
 * on the agl_shell interface be terminated. The client would need 
 * to bind again the agl_shell_ext and issue a 'doas_shell_client'
 * request.
 */
static inline void
agl_shell_ext_destroy(struct agl_shell_ext *agl_shell_ext)
{
	wl_proxy_marshal_flags((struct wl_proxy *) agl_shell_ext,
			 AGL_SHELL_EXT_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) agl_shell_ext), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_agl_shell_ext
 *
 * Prior to binding to agl_shell interface, this request would inform
 * the compositor that it wants to gain access the agl_shell interface.
 * The client is expected to wait for 'doas_shell_client_done' event and 
 * check for a successful status before going further with binding to
 * the agl_shell interface.
 */
static inline void
agl_shell_ext_doas_shell_client(struct agl_shell_ext *agl_shell_ext)
{
	wl_proxy_marshal_flags((struct wl_proxy *) agl_shell_ext,
			 AGL_SHELL_EXT_DOAS_SHELL_CLIENT, NULL, wl_proxy_get_version((struct wl_proxy *) agl_shell_ext), 0);
}

#ifdef  __cplusplus
}
#endif

#endif
